/*
Various utility functions for the validation code
This file is in the public domain
*/

#include <iostream>
#include <string>
#include <typeinfo>

// OpenCL headers
#include "filters.h"

#include "des.h"
#include "square.h"

#include "md5.h"
#include "rmd128.h"
#include "rmd160.h"
#include "sha1.h"

#include "emac.h"
#include "hmac.h"
#include "md5mac.h"
using namespace OpenCL;

Filter* get_mac(const std::string& algname, const SymmetricKey& key)
   {
   if(algname == "EMAC<Square>")
      return new MACFilter< EMAC<Square> >(key);
   else if(algname == "EMAC<DES>")
      return new MACFilter< EMAC<DES> >(key);
   else if(algname == "HMAC-MD5")
      return new MACFilter< HMAC<MD5> >(key);
   else if(algname == "HMAC-SHA1")
      return new MACFilter< HMAC<SHA1> >(key);
   else if(algname == "HMAC-RIPE-MD128")
      return new MACFilter< HMAC<RIPEMD128> >(key);
   else if(algname == "HMAC-RIPE-MD160")
      return new MACFilter< HMAC<RIPEMD160> >(key);
   else if(algname == "MD5-MAC") return new MACFilter<MD5MAC>(key);

   else return 0;
   }
