/*
Various utility functions for the validation code
This file is in the public domain
*/

#include <iostream>
#include <string>

// OpenCL headers
#include "filters.h"

#include "arc4.h"
#include "isaac.h"
#include "seal.h"

using namespace OpenCL;

// A version of SEAL parameterized for the test vectors given in the paper
struct SEAL_TESTVECTOR : public SEAL
   { SEAL_TESTVECTOR() : SEAL(0x013577AF, 4) {} };

Filter* get_stream(const std::string& algname, const SymmetricKey& key)
   {
   if(algname == "ARC4")
      return new StreamCipherFilter<ARC4>(key);
   else if(algname == "ISAAC")
      return new StreamCipherFilter<ISAAC>(key);
   else if(algname == "SEAL")
      return new StreamCipherFilter<SEAL_TESTVECTOR>(key);

   else return 0;
   }
