/*************************************************
* OpenCL Base Classes Source File                *
* (C) 1999-2001 The OpenCL Project               *
*************************************************/

#include "opencl.h"

namespace OpenCL {

/*************************************************
* Decrypt with a StreamCipher                    *
*************************************************/
void StreamCipher::decrypt(const byte in[], byte out[], u32bit len)
   { encrypt(in, out, len); }

void StreamCipher::decrypt(byte in[], u32bit len)
   { encrypt(in, in, len); }

/*************************************************
* Hash a complete message                        *
*************************************************/
void HashFunction::process(const byte in[], u32bit len, byte hash[])
   { update(in, len); final(hash); }

/*************************************************
* MAC a complete message                         *
*************************************************/
void MessageAuthenticationCode::process(const byte in[], u32bit len, byte mac[])
   { update(in, len); final(mac); }

/*************************************************
* Randomize an array of bytes                    *
*************************************************/
void RandomNumberGenerator::randomize(byte out[], u32bit len)
   {
   for(u32bit j = 0; j != len; j++)
      out[j] = random();
   }

}
